; AltTabFingertips -- by justice & Winkie

#NoEnv
#LTrim
SendMode, Input
DetectHiddenWindows, Off
#SingleInstance, Force
SetWinDelay, 0
OnExit, ExitATF

; Comment this line to use 'real' Lib
#Include, Lib\MI.ahk

ATF_Version = 2.0
ATF_VersionDate = 29 Nov 2009
ATF_IniFile = ATF_Settings.ini

Menu, Tray, Tip, AltTabFingertips %ATF_Version%
Menu, Tray, NoStandard
Menu, Tray,DeleteAll
Menu, Tray, Add, Show &AltTabFingertips, ShowATF 		;1
Menu, Tray, Default, Show &AltTabFingertips
Menu, Tray, Add, ; seperator								;2
Menu, Tray, Add, &Preferences, ShowSettings				;3
Menu, Tray, Add, &Edit exclusion list, WindowExclude	;4
Menu, Tray, Add, ; seperator								;5
Menu, Tray, Add, &Suspend hotkey, SuspendATF			;6
Menu, Tray, Add, ; seperator								;7
Menu, Tray, Add, &About AltTabFingertips, AboutATF 		;8
Menu, Tray, Add, ; seperator								;9
Menu, Tray, Add, &Exit, ExitATF							;10
hTrayMenu := MI_GetMenuHandle( "Tray" )

If ( A_OSVersion != "WIN_VISTA" )
{	; It is necessary to hook the tray icon for owner-drawing to work.
	; ( Owner-drawing is not used on Windows Vista )
	OnMessage( 0x404, "AHK_NOTIFYICON")
	MI_SetMenuStyle( hTrayMenu, 0x4000000 ) ; MNS_CHECKORBMP
}

If A_IsCompiled
{
	MI_SetMenuItemIcon(hTrayMenu, 1, A_ScriptFullPath, 1, 16)
	MI_SetMenuItemIcon(hTrayMenu, 6, A_ScriptFullPath, 3, 16)
}
Else
{
	MI_SetMenuItemIcon(hTrayMenu, 1, A_ScriptDir . "\atf.ico", 1, 16)
	MI_SetMenuItemIcon(hTrayMenu, 6, A_AhkPath, 3, 16)
	Menu, Tray, Icon, atf.ico
}
MI_SetMenuItemBitmap(hTrayMenu, 10, 8) ; exit

Gosub, ReadIni
Gosub, SetHotkey
Gosub, ShowTrayTip
Menu, ATF_Menu, Add ; Needed because menu-building starts with DeleteAll
Return

SetHotkey:
	Hotkey, %ATF_Hotkey%, ShowATF, ON
Return

ShowATF:
	RebuildMenu()
	;Menu, ATF_Menu, Show
	MI_ShowMenu("ATF_Menu")
Return

LaunchFile:
	WinActivate, %A_ThisMenuItem%
Return

ShowDesktop:
If bShowDesktop
{
		bShowDesktop := False
		WinMinimizeAllUndo
}
Else
{
		bShowDesktop := True
		WinMinimizeAll
}
Return

MenuExit:
Return

ReadIni:
	IniRead, ATF_ExclusionList, %ATF_IniFile%, ExclusionListSettings, List, %A_Space%
	IniRead, ATF_Hotkey, %ATF_IniFile%, HotkeySettings, Hotkey, F10
	IniRead, ATF_IconSize, %ATF_IniFile%, AppearanceSettings, IconSize, 16
	IniRead, ATF_TitleLen, %ATF_IniFile%, AppearanceSettings, TitleLen, 0
Return

ShowSettings:
	Gui, 1:Destroy
	Gui, 1:+LabelSettings
	Gui, 1:Margin, 10, 10
	Gui, 1:Font, Bold
	Gui, 1:Add, Text, xm w350 Section, AltTabFingertips Hotkey:
	Gui, 1:Font, Normal
	Gui, 1:Add, Checkbox, xm w350  vbAltTab gSettingsAltTabCheck
		, Use hotkey Alt-Tab for AltTabFingertips
	Gui, 1:Add, Text, xm+20 w180 vText1, Otherwise press hotkey:
	Gui, 1:Add, Hotkey, x+0 yp-3 w150 vATF_Hotkey, %ATF_Hotkey%
	Gui, 1:Add, Text, xm y+20 h1 w350 Border,
	Gui, 1:Font, Bold
	Gui, 1:Add, Text, xm w350, AltTabFingertips Appearance:
	Gui, 1:Font, Normal
	Gui, 1:Add, Text, xm w200, Menu icon size:
	Gui, 1:Add, DropDownList, x+0 yp-3 w150 vATF_IconSize Choose1, 16|32|48
	Gui, 1:Add, Text, xm w200 Number, Trim window titles: (no. characters)
	Gui, 1:Add, Edit, x+0 yp-3 w150 vATF_TitleLen, %ATF_TitleLen%
	Gui, 1:Add, Text, xm+20 w350, (Empty or 0 = disallow trimming)
	Gui, 1:Add, Text, xm w350,
	Gui, 1:Add, Button, ym w100 Default Section gSettingsApply, &OK
	Gui, 1:Add, Button, xs w100 gSettingsClose, &Cancel
	Gui, 1:Show, ,AltTabFingertips Preferences
Return

SettingsClose:
	Gui, 1: Destroy
Return

SettingsAltTabCheck:
	Gui, 1:Submit, NoHide
	If bAltTab
	{
		GuiControl, Disable, ATF_Hotkey
		GuiControl, Disable, Text1
	}
	Else
	{
		GuiControl, Enable, ATF_Hotkey
		GuiControl, Enable, Text1
	}
Return

SettingsApply:
	Gui, 1:Submit, NoHide
	If ( Not bAltTab And Not ATF_Hotkey )
	{
		Msgbox, 48, AltTabFingertips, Please specify an hotkey in the hotkey box.
		Return
	}
	Gui, 1:Destroy
	If bAltTab
		ATF_Hotkey = !Tab
	If Not ATF_TitleLen
		ATF_TitleLen = 0
	Gosub, SetHotkey
	Gosub, ShowTrayTip
Return

WindowExclude:
	Gui, 2:Destroy
	Gui, 2:Default
	Gui, 2:+LabelExclude
	Gui, 2:Margin, 12, 12
	Gui, 2:Add, Text, xm w578,
	(
		Here you can edit the exclusion list for AltTabFingertips.
		Excluded applications won't show in the AltTabFingertips menu.
	)
	Gui, 2:Add, ListView, h250 w280 xm Checked Grid Section -E0x200 vListView1
		, Currently running applications
	Gui, 2:ListView, ListView1
	LoadListView1()
	Gui, 2:Add, Button, xs w280 gToExclusionList, Add to exclusion list
	Gui, 2:Add, ListView, h250 w280 ys Checked Grid Section -E0x200 vListView2
		, AltTabFingertips exclusion list
	Gui, 2:ListView, ListView2
	Loop, Parse, ATF_ExclusionList,`,
	{
		LV_Add( "", A_LoopField )
	}
	Gui, 2:Add, Button, xs w280 gFromExclusionList, Remove from exclusion list
	Gui, 2:Add, Text, xm w578 h8,
	Gui, 2:Add, Button, ym w100 Default Section gExcludeApply, &OK
	Gui, 2:Add, Button, xs w100 gExcludeClose, &Cancel
	Gui, 2:Show, , AltTabFingertips exclusion list
Return

ToExclusionList:
	LV_MoveItems( "ListView1", "ListView2" )
	LoadListView1()
Return

FromExclusionList:
	LV_MoveItems( "ListView2" )
	LoadListView1()
Return

ExcludeApply:
	ATF_ExclusionList := GetListView2()
	Gui, 2:Destroy
Return

ExcludeClose:
	Gui, 2:Destroy
Return

AboutATF:
	Gui, 3:Destroy
	Gui, 3:+LabelAbout
	Gui, 3:Margin, 10,10
	Gui, 3:Font, Bold
	Gui, 3:Add, Text, xm y w320, % F_HotkeyString( ATF_Hotkey ) . "   -   Switch between active windows"
	Gui, 3:Font
	Gui, 3:Add, Text, xm Section, Version:
	Gui, 3:Add, Text, xs, Author:
	Gui, 3:Add, Text, xs h40, Website:
	Gui, 3:Add, Text, xs h40, Made with:
	Gui, 3:Add, Text, ys Section, % ATF_Version . " (" . ATF_VersionDate . ")"
	Gui, 3:Add, Text, xs, justice && Winkie
	Gui, 3:Font, cBlue Underline
	Gui, 3:Add, Text, xs h40 gGoOnlineDc, DonationCoder`nhttp://www.donationcoder.com/Forums/
	Gui, 3:Add, Text, xs h40 gGoOnlineAhk, AutoHotkey`nhttp://www.autohotkey.com/
	Gui, 3:Font
	Gui, 3:Font, Bold
	Gui, 3:Add, Text, xm,Thanks to:
	Gui, 3:Font
	Gui, 3:Add, Text, xm,
	(
		- Chris Mallett and AutoHotkey Community for AutoHotkey!
		- DonationCoder.com Community for feedback and testing!
		- Lexikos for the functions and samples to implement menu icons!
	)
	Gui, 3:Add, Text, xs,
	Gui, 3:Add, Button, ym w100 Section Default gAboutOk, &OK
	Gui, 3:Show, , About AltTabFingerTips
	hCurs:=DllCall( "LoadCursor", "UInt", NULL, "Int", 32649, "UInt") ;IDC_HAND
	OnMessage( 0x200, "WM_MOUSEMOVE" )
Return

AboutClose:
AboutOk:
	Gui, 3:Destroy
	OnMessage( 0x200, "" )
	DllCall( "DestroyCursor", "Uint", hCur )
Return

GoOnlineDc:
	Run, http://www.donationcoder.com/Forums/bb/index.php?topic=10629.0,,UseErrorLevel
Return

GoOnlineAhk:
	Run, http://www.autohotkey.com/,,UseErrorLevel
Return

ShowTrayTip:
	Traytip,% "AltTabFingertips " . ATF_Version
		, % F_HotkeyString( ATF_Hotkey ) . "   -   Switch between active windows", ,17
	SetTimer, RemoveTrayTip, 3500
Return

RemoveTrayTip:
	SetTimer, RemoveTrayTip, Off
	TrayTip
Return

SuspendATF:
	Suspend
Return

ExitATF:
	IniWrite, %ATF_ExclusionList%, %ATF_IniFile%, ExclusionListSettings, List
	IniWrite, %ATF_Hotkey%, %ATF_IniFile%,HotkeySettings, Hotkey
	IniWrite, %ATF_IconSize%, %ATF_IniFile%, AppearanceSettings, IconSize
	IniWrite, %ATF_TitleLen%, %ATF_IniFile%, AppearanceSettings, TitleLen
	ExitApp
Return

F_HotkeyString( Hotkey )
{
	StringReplace, str, Hotkey, +, Shift-, All
	StringReplace, str, str, #, Win-, All
	StringReplace, str, str, !, Alt-, All
	StringReplace, str, str, ^, Control-, All
	Return str
}

RebuildMenu( )
{
	Global ATF_ExclusionList, ATF_IconSize, ATF_TitleLen, bShowDesktop

	Menu, ATF_Menu, DeleteAll
	hRootMenu := MI_GetMenuHandle( "ATF_Menu" )

	WinGet, sWindowList, List
	Loop, %sWindowList%
	{
		WinGetTitle, sName, % "ahk_id " sWindowList%A_Index%
		If Not sName
			Continue
		If sName = Program Manager
			Continue
		WinGet, sProcess, ProcessName, % "ahk_id " sWindowList%A_Index%
		If sProcess in %ATF_ExclusionList%
			Continue
		
		i++
		If ATF_TitleLen
			StringLeft, sName, sName, ATF_TitleLen
		StringReplace, sName, sName, &, &&, All
		Menu, ATF_Menu, Add, %sName%, LaunchFile
		WinGet, pid, PID, % "ahk_id " sWindowList%A_Index%
		sCommandLine := GetCommandLine( pid )
		StringLen, len, sProcess
		StringGetPos, start, sCommandLine, %sProcess%, L1
		StringLeft, sProcessPath, sCommandLine, start + len
		MI_SetMenuItemIcon( hRootMenu, i, sProcessPath, 1, ATF_IconSize )
	}
	Menu, ATF_Menu, Add
	If bShowDesktop
		Menu, ATF_Menu, Add, Restore All Windows,ShowDesktop
	Else
		Menu, ATF_Menu, Add, Show Desktop,ShowDesktop
	i += 2
	MI_SetMenuItemIcon( hRootMenu, i, A_WinDir . "\System32\shell32.dll", 35, ATF_IconSize )
	Menu, ATF_Menu, Add
	Menu, ATF_Menu, Add, &Quit This Menu, MenuExit
	i += 2
	MI_SetMenuItemBitmap( hRootMenu, i, 8 ) ; exit
	MI_SetMenuStyle( hRootMenu, 0x04000000 ) ; MNS_CHECKORBMP
}

LoadListView1()
{
	Global ATF_ExclusionList
	
	Gui, 2:ListView, ListView1
	LV_Delete()
	WinGet, sWindowList, List
	Loop, %sWindowList%
	{
		WinGetTitle, sName, % "ahk_id " sWindowList%A_Index%
		If Not sName
			Continue
		If sName = Program Manager
			Continue
		WinGet, sProcess, ProcessName, % "ahk_id " sWindowList%A_Index%
		If sProcess in %ATF_ExclusionList%
			Continue
		LV_Add( "", sProcess )
	}
}

GetListView2()
{
	Gui, 2:ListView, ListView2
	Loop, % LV_GetCount()
	{
		LV_GetText( str, A_Index, 1 )
		var .= ( var ? "," : "" ) . str
	}
	Return var
}

LV_MoveItems( From, To = 0 )
{
	Loop
	{
		row = 0
		Gui, 2:ListView, % From
		row := LV_GetNext( row, "C" )
		If Not row
			Break
		LV_GetText( var, row, 1 )
		LV_Delete( row )
		If To
		{
			Gui, ListView, % To
			LV_Add( "", var )
		}
	}
}

; Function by Skrommel
WM_MOUSEMOVE( wParam, lParam )
{
	Global hCurs
	MouseGetPos,,,,ctrl
	If ctrl in Static8,Static9
		DllCall( "SetCursor", "UInt",hCurs )
	Return
}

; Function from MI example -- by Lexikos -- http://www.autohotkey.com/forum/topic21991.html
AHK_NOTIFYICON( wParam, lParam )
{
	Global hTrayMenu
	If (lParam = 0x205) ; WM_RBUTTONUP
	{
;		; Update "Suspend Script" checkmark -- Control ID: 110006 ( Standard Suspend: 65305 )
		DllCall( "CheckMenuItem", "uint", hTrayMenu, "uint", 11006, "uint", A_IsSuspended ? 8:0 )
		; Show menu to allow owner-drawing.
		MI_ShowMenu( hTrayMenu )
		Return 0
	}
}

; Function by Sean -- http://www.autohotkey.com/forum/viewtopic.php?t=16575
; Edited by Winkie
GetCommandLine( PID )
{
	Static pFunc
	If ! ( hProcess := DllCall( "OpenProcess", UInt,0x043A, Int,0, UInt, PID ) )
		Return
	If pFunc=
		pFunc := DllCall( "GetProcAddress", UInt
			, DllCall( "GetModuleHandle", Str,"kernel32.dll" ), Str,"GetCommandLineA" )
	hThrd := DllCall( "CreateRemoteThread", UInt,hProcess, UInt,0, UInt,0, UInt,pFunc, UInt,0
		, UInt,0, UInt,0 )
	DllCall( "WaitForSingleObject", UInt,hThrd, UInt,0xFFFFFFFF )
	DllCall( "GetExitCodeThread", UInt,hThrd, UIntP,pcl ), VarSetCapacity( sCmdLine,512 )
	DllCall( "ReadProcessMemory", UInt,hProcess, UInt,pcl, Str,sCmdLine, UInt,512, UInt,0 )
	DllCall( "CloseHandle", UInt,hThrd ), DllCall( "CloseHandle", UInt,hProcess )
	StringReplace, sCmdLine, sCmdLine, ", , All
	sCmdLine := sCmdLine
	Return sCmdLine
}